function fig = ballbeamgui(csetup)

% BALL ON A BEAM ver. 1.0
% 
% GUI
% 
% 2007 Joo Paulo Coelho
%

load ballbeamgui

Fig = figure('Color',[0.8 0.8 0.8], ...
   'Colormap',mat0, ...
   'CloseRequestFcn','',...
	'FileName','C:\MATLABR11\work\BallBeam\ballbeamgui.m', ...
	'MenuBar','none', ...
	'Name','Ball on Beam', ...
	'NumberTitle','off', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[532 260 604 383], ...
   'Tag','Fig1', ...
	'ToolBar','none');
Eixo = axes('Parent',Fig, ...
   'Units','normalized', ...
   'Xlim',    [-20 20],...
   'Ylim',    [-20 20],...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
	'Color',[1 1 1], ...
	'ColorOrder',mat1, ...
	'Position',[0.00993377483444   0.01305483028721   0.63907284768212   0.97127937336815], ...
	'Tag','Eixo', ...
	'Visible','off', ...
	'XColor',[0 0 0], ...
	'XTickLabelMode','manual', ...
	'YColor',[0 0 0], ...
	'YTickLabelMode','manual', ...
   'ZColor',[0 0 0]);
	axis square;
Copyright = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'FontName','Arial', ...
	'FontSize',10, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[309 66.75 113.25 12.75], ...
	'String','2007 Joo Paulo Coelho', ...
	'Style','text', ...
	'Tag','StaticText1', ...
	'TooltipString','www.ipb.pt/~jpcoelho.htm');
Frm = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'ListboxTop',0, ...
	'Position',[309 82.5 133.5 58.5], ...
	'Style','frame', ...
	'Tag','Frame1');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[321.75 107.25 36 11.25], ...
	'String','Angulo:', ...
	'Style','text', ...
	'Tag','StaticText2');
Angulo = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0 0 0], ...
	'ForegroundColor',[0 1 0], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[360 106.5 55.5 12.75], ...
	'String',num2str(csetup.theta*180/pi), ...
	'Style','edit', ...
	'Tag','angulo');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[417.75 107.25 20.25 11.25], ...
	'String','deg', ...
	'Style','text', ...
	'Tag','StaticText2');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 123 34.5 11.25], ...
	'String','Posio:', ...
	'Style','text', ...
   'Tag','StaticText2');
Posicao = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0 0 0], ...
	'ForegroundColor',[0 1 0], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[360 122.25 55.5 12.75], ...
	'String',num2str(100*csetup.x), ...
	'Style','edit', ...
	'Tag','posicao');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[417.75 123 20.25 11.25], ...
	'String','cm', ...
	'Style','text', ...
	'Tag','StaticText2');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[312.75 91.5 45 11.25], ...
	'String','Velocidade:', ...
	'Style','text', ...
   'Tag','StaticText2');
Velocidade = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0 0 0], ...
	'ForegroundColor',[0 1 0], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[360 90.75 55.5 12.75], ...
	'String',num2str(csetup.veloc), ...
	'Style','edit', ...
	'Tag','velocidade');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[417.75 91.5 20.25 11.25], ...
	'String','m/s', ...
	'Style','text', ...
	'Tag','StaticText2');

%--------------Perturbao...
Frm = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'ListboxTop',0, ...
	'Position',[309 144.75 133.5 45.75], ...
	'Style','frame', ...
	'Tag','Frame1');
DLeft = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
   'CData',mat4, ...
   'CallBack','ballbeamdyn([],[],[],''LeftDisturb'')',...
	'ListboxTop',0, ...
	'Position',[360 150.75 20.25 18], ...
	'Tag','distleft');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[309.75 154.5 48 11.25], ...
	'String','Perturbao:', ...
	'Style','text', ...
   'Tag','StaticText3');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[319.5 171.75 38.25 11.25], ...
	'String','Varincia:', ...
	'Style','text', ...
	'Tag','StaticText3');
Disturb = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0 0 0], ...
	'ForegroundColor',[0 1 0], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[360 170.25 55.5 12.75], ...
	'String','10', ...
	'Style','edit', ...
   'Tag','posicao');
Txt = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.925490196078431 0.913725490196078 0.847058823529412], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[417.75 171 20.25 11.25], ...
	'String','%', ...
	'Style','text', ...
	'Tag','StaticText2');
DRight = uicontrol('Parent',Fig, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
   'CData',mat5,...
   'CallBack','ballbeamdyn([],[],[],''RightDisturb'')',...
	'ListboxTop',0, ...
	'Position',[395.25 150.75 20.25 18], ...
	'Tag','distleft');



%-----------------------------------------------------
%       BALANC
%-----------------------------------------------------
%-----------------------------------------------------
%   Caractersticas Mecnicas
%-----------------------------------------------------
L=csetup.l*csetup.fescala;       % L - Comprimento do Brao
A=csetup.a*csetup.fescala;       % A - Largura do Brao
theta=csetup.theta;
xo=L*cos(theta);yo=L*sin(theta); % xo e yo - Posio do segmento director com base no angulo
dx=A*sin(theta);dy=A*cos(theta); % dx e dy - Diferenciais requeridos para modelar a largura do brao
Balance = surface(...
  'Parent',   Eixo,...
  'XData',    [-(xo+dx/2) -(xo-dx/2);xo-dx/2 xo+dx/2],...
  'YData',    [yo-dy/2 yo+dy/2;-(yo+dy/2) -(yo-dy/2)],...
  'ZData',    zeros(2),...
  'FaceColor',[0.56 1 0.5]);
%-----------------------------------------------------
%       FULCRO
%-----------------------------------------------------
%-----------------------------------------------------
%   Caractersticas Mecnicas
%-----------------------------------------------------
F=csetup.f*csetup.fescala;      % F- Altura do fulcro
P=csetup.p*csetup.fescala;      % P - Largura da base
Fulcro = surface(...
  'Parent',   Eixo,...
  'XData',    [-P/2 0;0 P/2;-P/2 P/2],...
  'YData',    [-F 1;1 -F;-F -F],...
  'ZData',    zeros(3,2),...
  'FaceColor',[0.5 0.5 0.5]);
Shaft=patch(...
  'Parent',   Eixo,...
  'XData',    .3*cos(0:pi/100:2*pi),...
  'YData',    .3*sin(0:pi/100:2*pi),...
  'FaceColor',[0 1 0]);
%-----------------------------------------------------
%       BOLA
%-----------------------------------------------------
Bola=patch(...
  'Parent',   Eixo,...
  'XData',    csetup.fescala*(csetup.r*cos(0:pi/100:2*pi)+csetup.x),...
  'YData',    csetup.fescala*(csetup.r*sin(0:pi/100:2*pi)+csetup.y),...
  'FaceColor',[1 0 0]);
  
  
HndStruc.Eixo=Eixo;
HndStruc.Bola=Bola;
HndStruc.Balace=Balance;
HndStruc.Angulo=Angulo;
HndStruc.Posicao=Posicao;
HndStruc.Velocidade=Velocidade;
HndStruc.Disturb=Disturb;
HndStruc.csetup=csetup;
set(Fig,'UserData',HndStruc);

if nargout==1,fig=Fig;end