function dxdt=ballbeamode(t,x,flags,u,r,m,g,L,Ib,cf)

% MODELO No-Linear SIMPLIFICADO...
% m  - massa da bola
% g  - acelerao da gravidade
% r  - raio da bola
% L  - comprimento da calha
% Ib - momento de inrcia da bola
% u - Angulo (entrada)
% cf - coeficiente de frico
% 2007 Joo Paulo Coelho

%  -     -   -    -   -    -   - -
% | dx(t) | | 0  1 | | x(t) | | 0 |
% |       |=|      |*|      |+|   |*u(t)
% | dv(t) | | 0  0 | | v(t) | | K |
%  -     -   -    -   -    -   - -
% RETORNA um vector coluna onde
% x0=posicao e x1=velocidade

x0=x(1); % Posio
x1=x(2); % Velocidade

I=m*r^2*2/5;
K=6*pi*r;  % Fora de atrito (ar sovre esfera) = -K*cf*v(t)
%nota          -----|                         | (?+)
dxdt=[0 1;0 -K*cf/(m-I/r^2)]*[x0;x1]+[0;m*g/(m-I/r^2)]*sin(u); % No notei grande diferena...
